//XSETASETA@GMAIL.COM
//SETA43
// 2017

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

#include "main.h"

//Velocidad de muestreo
// windows lento
#if YesWindows 
    #define XTIEMPO3	10
#else
	#define XTIEMPO3	20
#endif

#define MAXENTRADA 50
#define MAXINPUT 1030


char buffer[MAXENTRADA];

int  ContadorI=0;
unsigned char Binput[MAXINPUT];
unsigned char Binput2[10];
char FinContador=1;

int tiempo2=2,tiempo1=2, tiempo3=2;
int  DatosPan[MAXINPUT];
int	 IndexDatos;
int  xtiempo2=10;

int DIVISION=16;
int MUESTRAS;
int MUESTREO;

int MODO;
int MODOLINE;

int DESPLAZAMIENTO;
int ZOOM;

int V33;

unsigned char portok;

//_________________________

void EV_Init();
void MiTimer();
void SetLuz(int z);
void PrintTextI(int num,int n);
void PrintTextF(int num,float f);
void Representar(int z);
void PresentarVol(int z);

void PrintTextAll(void);

void PutPixel(SDL_Surface *surface, int x, int y, Uint32 pixel);
void SDL_DrawLine(SDL_Surface* pDestination, int pX1, int pY1, int pX2, int pY2, Uint32 pColour );

void PintarMover(int yp);
void RepintarPantalla();
void SetLuz(int z);
void SetLinePuntos(int z);
void  Mentradas();

void ModifiG();

int SearchPort();
int test3v3(void);

void printConsole( char *p);

int main (int argc, char *argv[])
{
	int quit = 0;
	int mouse_x,mouse_y;
	Uint8 *teclas; 
	int zboton=0;
	int z,zz;
		
#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif
	printf("SDL_Osci_ARDU\n");

    Initextos();
	Inibotones();
	IniLuces ();
	Inientradas();
	
		
	if( init() == 0 ) return 1;	
	if( load_files() == 0 ) return 2;	
	RepintarPantalla();	
	if( SDL_Flip( screen ) == -1 ) return 3;
	
	RepintarPantalla();

		z=SearchPort();
		if(z==-1)z=SearchPort();
		if(z==-1)
			{
			 printf("No encontrado OSCILOSCOPIO %d\n",z);
			 for(zz=0;zz<600;zz++)
				{
					SDL_DrawLine(screen,0,zz,800,zz,0xFFFFFF);
				}
			 PrintTextAll();
			 SDL_Flip( screen );
			 DelayMs(4000);
			 clean_up();
			 SDL_Delay(1000);			 
			 return 4;  
			}
			else
		     {
			  MODEMDEVICE=myport[z]; 
			 }
      	
#if YesWindows
	if(hSerial)CloseRs232();
#else		
	if(fdrs232)CloseRs232();
#endif		 

	if(0!=IniRs232())
	{
		#ifdef DEBUG 
			printf("NO %s\n",MODEMDEVICE);
		#endif
		portok=0;
	}
	else
	{		
		#ifdef DEBUG 
			printf("SI %s\n",MODEMDEVICE);  		
		#endif
		portok=1;
	}			
	
	if(portok==1) V33=test3v3();
	
	MODO=1; 
	SetLuz(1);
	MODOLINE=0;
	SetLinePuntos(0);
	
	PaintLuces();
	SDL_Flip( screen );
	
	PrintTextI(1,xtiempo2);
	
	ZOOM=1;

	ModifiG();
	
	Mentradas();
	PrintTextAll();
	while( quit == 0 )
	{	
		SDL_Delay(5);	  
		MiTimer();								  	  
		while( SDL_PollEvent( &event ) )
		{
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] )
			{					
				printf("K_END Programa\n");	goto salir;
			}
			if( event.type == SDL_QUIT )   quit = 1;
			if( event.type == SDL_KEYDOWN ) 
			{
				#ifdef DEBUG 
					printf("Evento Tecla\n");
				#endif
				if(event.key.keysym.sym == SDLK_f)
				{  
          #if YesWindows
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
          #else
					SDL_WM_ToggleFullScreen(screen);
          #endif  
					RepintarPantalla();
				}
				if(event.key.keysym.sym == SDLK_m)
				{
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					RepintarPantalla();
				}
			}
			
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				if(zboton!=-1)
				{             					
					switch (zboton)
					{                         
						case 0: 							
						#ifdef DEBUG 
							printf("B_END Programa\n");
						#endif
						goto salir;
						break;    
						case 1: 
						#ifdef DEBUG 
							printf("B_>\n");
						#endif
						if(xtiempo2<30)xtiempo2++;
						PrintTextI(1,xtiempo2);			
						break;                          						     
						case 2:
						#ifdef DEBUG 
							printf("B_<\n");
						#endif						
						if(xtiempo2>0)xtiempo2--;
						PrintTextI(1,xtiempo2);
						break; 
						case 3:
						#ifdef DEBUG 
							printf("Volt\n");
						#endif
							MODO=0; 
							SetLuz(0);
							nluz[0].estado=1;             
						break; 
						case 4:
						#ifdef DEBUG 
							printf("Auto\n");
						#endif
							MODO=1; 
							SetLuz(1);					                          
						break; 
						case 5:
						#ifdef DEBUG 
							printf("B_5\n");
						#endif
							if(DIVISION>4) DIVISION/=2;	
							Mentradas();					
						break;
						case 6:
						#ifdef DEBUG 
							printf("GETUP\n");						
		                #endif
							if(MODO==1)SDL_Delay(300);
							MODO=2; 
							SetLuz(2);
							FinContador=0;
							ContadorI=0;
							PrintSerial((char *)"GETUP=\n"); 
						break; 
						case 7:
						#ifdef DEBUG 
							printf("GETDOWN\n");					            
						#endif
							if(MODO==1)SDL_Delay(300);
							MODO=3; 
							SetLuz(3);
							FinContador=0;
							ContadorI=0;
							PrintSerial((char *)"GETDOWN=\n"); 
						break; 
						case 8:
						#ifdef DEBUG 
							printf("B_8\n");
						#endif
							if(DIVISION<128) DIVISION*=2;
							Mentradas();
						break;
						case 9:
						#ifdef DEBUG 
							printf("B_9\n");
						#endif
							MODOLINE=0;
							SetLinePuntos(0);
						break;
						case 10:
						#ifdef DEBUG 
							printf("B_10\n");
						#endif
							MODOLINE=1;
							SetLinePuntos(1);
						break;
						case 13:
						#ifdef DEBUG 
							printf("B_13\n");
						#endif
							if(DESPLAZAMIENTO>0) DESPLAZAMIENTO--;
							Representar(0);
							ModifiG();
						break;
						case 14:
						#ifdef DEBUG 
							printf("B_14\n");
						#endif
							DESPLAZAMIENTO=0;
							Representar(0);
							ModifiG();
						break;
						case 15:
						#ifdef DEBUG 
							printf("B_15\n");
						#endif
							if(DESPLAZAMIENTO<700) DESPLAZAMIENTO++;
							Representar(0);
							ModifiG();
						break;
						case 16:
						#ifdef DEBUG 
							printf("B_16\n");
						#endif
							if(ZOOM>1) ZOOM-=1;
							Representar(0);
							ModifiG();
						break;
						case 17:
						#ifdef DEBUG 
							printf("B_17\n");
						#endif
							ZOOM=1;
							Representar(0);
							ModifiG();
						break;
						case 18:
						#ifdef DEBUG 
							printf("B_18\n");
						#endif
							if(ZOOM<10) ZOOM+=1;
							Representar(0);
							ModifiG();
						break;
						
					} 
					PaintBoton(zboton,1);
					PrintTextAll();
				}
				#ifdef DEBUG 
					printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);	
				#endif
			}
			if( event.type == SDL_MOUSEBUTTONUP ) 
			{
				if(zboton!=-1)
				{
					SDL_Delay(100);
					PaintBotones();
					PaintLuces();
					SDL_Flip( screen );
				}
				
				#ifdef DEBUG 
					printf("RepintarBoton %d\n",zboton);
				#endif
				zboton=-1;					
			}
		}
	}
	
	salir: 
     //Cerrar todo el SDL
	clean_up();
	SDL_Delay(1000);
	CloseRs232();
	return 0;  
}



//____________________FIN____________

void MiTimer()
{
	unsigned int z,zz;
	int nbytes;
	tiempo1--;	
	tiempo2--;	
	tiempo3--;

// cada __tiempo2__ msegundos
	if(portok==1 && tiempo2<0)
	{
		tiempo2=2;	
		
#if YesWindows
		while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
			while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
			 	Binput[ContadorI]=Binput2[0];
				if(ContadorI<MAXINPUT-1)	
					{
						ContadorI++;
						//printf(" %d %d\n",ContadorI,Binput2[0]);
						//sprintf(VARI,"Conta=%d",ContadorI);	printConsole(VARI);
						if(ContadorI==820)
						{
							for(z=10,zz=0;z<810;z++,zz++) DatosPan[zz]=Binput[z];																		
							Representar(0);
							if(!strncmp((char *)Binput+810,"FIN",3))	tiempo3=XTIEMPO3;							
						}
					}
					else
					{ 	FinContador=1;}									
			}
		}	 

// cada __tiempo1	
		if(MODO==0 && tiempo1<0)
		{	
			PresentarVol(Binput[15]);
			//printf("Fin contador1 %d\n",ContadorI);
			//for(z=0;z<30;z++) printf("%c",Binput[z]);
			tiempo1=xtiempo2;
			FinContador=0;
			ContadorI=0;
			PrintSerial((char *)"VOL=\n");
		}
				
// cada __tiempo3 
		if( MODO==1 && tiempo3<0)
		{
			tiempo3=120;			
			FinContador=0;
			ContadorI=0;
			PrintSerial((char *)"GETUP=\n"); 
		}
	}

//______________________test 3.3V	
int test3v3(void)
{
 unsigned int zz;
 int nbytes;
 
 ContadorI=0;	
 printConsole("Test 3V3");
 DelayMs(2000);
 PrintSerial((char *)"TEST=\n");

	for(zz=0;zz<15;zz++)
		{
		 DelayMs(200);
#if YesWindows
		while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
			  Binput[ContadorI]=Binput2[0];
			 // printf(" %d %d\n",ContadorI,Binput2[0]);
			  if(ContadorI<MAXINPUT-1)	
					{
					 ContadorI++;
					 if(ContadorI>29) goto salir;						
					}													
			}
		}
salir:
	zz=Binput[10]+Binput[11]+Binput[12]+Binput[13];
	zz=zz>>2;
	printf("Test 3v3=%d\n",zz);
	return(zz);
}

void PresentarVol(int z)
{
	long z1;
			
			z1=(z*3300)/V33;
			sprintf(VARI,"%li mV",z1);
			TextEntrada(0,VARI);
			PintarMover(z);
			//printf("Vol>%d\n",z);
			PintarMover(Binput[15]);
			PrintTextAll();
			SDL_Flip( screen );
}


void Representar(int z)
{
	SDL_Rect desti;
	SDL_Rect orig;
	int x,xx;
	  
  switch(z)
	{
		case 0:						
			orig.x=0;	
			orig.y=100;
			orig.w=800; 
			orig.h=256;
				
			desti.x=1;
			desti.y=100;
			SDL_BlitSurface(background,&orig,screen,&desti);
							
			xx=0;
			if(MODOLINE==1) for(x=DESPLAZAMIENTO;x<800 && xx<800;x++,xx+=ZOOM) PutPixel(screen,xx,355-DatosPan[x],0xFFFFFF);			
			if(MODOLINE==0) for(x=DESPLAZAMIENTO;x<798 && xx<800+ZOOM;x++,xx+=ZOOM) SDL_DrawLine(screen,xx,355-DatosPan[x],xx+ZOOM,355-DatosPan[x+1],0xFFFFFF);
			
			
			SDL_Flip( screen );			
		break;
	}
	
}

void ModifiG()
{
	sprintf(VARI,"%d",DESPLAZAMIENTO);
	TextEntrada(6,VARI);
	sprintf(VARI,"x%d",ZOOM);
	TextEntrada(7,VARI);
}	


void PintarMover(int yp)
{
 int z;
 SDL_Rect orig;
	for(z=0;z<256;z++)
		{
			PutPixel(screen,0,100+z,0x000000);
		}
	PutPixel(screen,0,100,0xFFFF00);
	PutPixel(screen,0,228,0xFF00FF);
	PutPixel(screen,0,355,0x00FFFF);
	
	PutPixel(screen,0,355-yp,0xFFFFFF);
	SDL_Rect desti;
	orig.x=0;	
	orig.y=100;
	orig.w=800; 
	orig.h=256;
				
	desti.x=1;
	desti.y=100;
	SDL_BlitSurface(screen,&orig,screen,&desti);
	SDL_Flip( screen );	
}

void PrintTextAll(void)
{	
	if(portok==1)
		TextEntrada(2,MODEMDEVICE);
	 else
		TextEntrada(2,"No_Osci");
	SDL_Flip( screen );
} 


int load_files()
{
	background = load_image( "modelo2.png" );
	if( background == NULL )  return 0;
	dots = load_image( "modelo1.png" );
	if( dots == NULL )  return 0;

	font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
	{
		printf("Error cargando Font\n");
		return 0;
	}	
	return 1;
}

void RepintarPantalla()
{
	SDL_WM_SetCaption( "Osciloscopio_ARDU_sdl", NULL );
	apply_surface( 0, 0, background, screen );
	
	PaintBotones();
	PaintLuces();
	PaintEntradas();
	PaintTextos();
	PrintTextAll();
	SDL_Flip( screen );
}
void SetLuz(int z)
{
	nluz[0].estado=0;
	nluz[1].estado=0;
	nluz[2].estado=0;
	nluz[3].estado=0;
	nluz[z].estado=1;
}

void SetLinePuntos(int z)
{
	nluz[4].estado=0;
	nluz[5].estado=0;
	if(z==0)
		nluz[4].estado=1;
	 else
		nluz[5].estado=1;
}

void  Mentradas()
{
	switch(DIVISION) 
	{
    case 4:
		sprintf(VARI,"212.000 m/s");   
    break;
	case 8:
		sprintf(VARI,"124.000 m/s");   
    break;
    case 16:
		sprintf(VARI,"66.000 m/s");   
    break;
    case 32:
		sprintf(VARI,"35.500 m/s");   
    break;
    case 64:
		sprintf(VARI,"17.900 m/s");   
    break;
    case 128:
		sprintf(VARI,"8.880 m/s");   
    break;
	}
				//sprintf(VARI,"%d m/s  ",1000000/DIVISION);
				TextEntrada(4,VARI);
				sprintf(VARI,"DIV%d",DIVISION);
				TextEntrada(3,VARI);														
				PrintSerial(VARI);	PrintSerial((char *)"\n");	
}


//____________
void PutPixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}


void SDL_DrawLine(SDL_Surface* pDestination, int pX1, int pY1, int pX2, int pY2, Uint32 pColour )
{
    int lenX,lenY;
    int vectorI;
    int i, locked;
    float vectorLen,x,y,inclineX,inclineY;
    
	lenX = pX2 - pX1;
    lenY = pY2 - pY1;
   
    vectorLen = sqrtf(lenX * lenX + lenY * lenY);
    vectorI=vectorLen;
    
    if(vectorI == 0)   return;

    inclineX = lenX / vectorLen;
    inclineY = lenY / vectorLen;

    x = (int)pX1;
    y = (int)pY1;

    locked = SDL_MUSTLOCK(pDestination);
    if(locked)   SDL_LockSurface(pDestination);

    for(i = 0; i < vectorI; ++i)
    {
        PutPixel(pDestination, (int)x, (int)y, pColour);
        x += inclineX;
        y += inclineY;
    }

    if(locked)  SDL_UnlockSurface(pDestination);
}

void printConsole( char *p)
{
    TextEntrada(2,p);
	SDL_Flip( screen ); 
}     
	
//______________

	int SearchPort()
	{
		int z,zz,nbytes;
		
		printf("Search serial\n");
		printConsole("Search serial");
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif		
			{
				MODEMDEVICE=myport[z];
				#ifdef DEBUG 
					printf("Port %s\n",MODEMDEVICE);
				#endif
				sprintf(VARI,"Port %s",MODEMDEVICE);	printConsole(VARI);
				if(0==IniRs232())
				{               
					DelayMs(1000);
					PrintSerial((char *)"inicio\n\n"); 
					DelayMs(100);
					PrintSerial((char *)"OSCI=\n");
					DelayMs(100);
					
					ContadorI=0; 
					for(zz=0;zz<15;zz++)
					{
						DelayMs(200);
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
							while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
							{	
							 //printf("Leer %d -> %s\n",nbytes,Binput2);
								Binput[ContadorI]=Binput2[0];
								ContadorI++;
								if (Binput2[0] == '\n')
								{
									if(ContadorI<2)ContadorI=2;   
									Binput[ContadorI-1]=0;
									ContadorI=0;	
									sprintf(VARI,"%s",Binput);
									#ifdef DEBUG 
										printf("==%s\n",VARI);
									#endif
									if(!strncmp(VARI,"OK",2))
									{
										printf("OsciSDL found at %s\n",MODEMDEVICE);
										sprintf(VARI,"Found at %s",MODEMDEVICE); printConsole(VARI);										
										CloseRs232();                                   
										return z;
									}			
								}
							}	  	  
						}             
					}
					CloseRs232();
				}
				printf("Osci no found \n");
				return -1;
			}

void PrintTextI(int num,int n)
	{
		sprintf(VARI,"%d",n);
		TextEntrada(num,VARI);
	}

void PrintTextF(int num,float f)
	{
		sprintf(VARI,"%.2f",f);
		TextEntrada(num,VARI);
	}
